#include <stdio.h>
#include <stdlib.h>

static int gcd(int m, int n)
{
	int tmp;
	while (n > 0) {
		tmp = n;
		n = m % n;
		m = tmp;
	}
	return m;
}

/*******************************************/

typedef struct _fraction {
	int numerator;
	int denominator;
} fraction_t;

/*******************************************/

void frac_print(fraction_t frac)
{
	printf("fraction(%d / %d)", frac.numerator, frac.denominator);
}

fraction_t frac_reduce(fraction_t frac)
{
	fraction_t res;
	int divider = gcd(frac.numerator, frac.denominator);
	res.numerator = frac.numerator / divider;
	res.denominator = frac.denominator / divider;
	return res;
}

fraction_t frac_mul(fraction_t a, fraction_t b)
{
	fraction_t res;
	res.numerator = a.numerator * b.numerator;
	res.denominator = a.denominator * b.denominator;
	return frac_reduce(res);
	// return res;
}

int main()
{
	fraction_t a = {-1, 2}, b = {4, 6};
	fraction_t c;
	
	frac_print(b);
	printf(" = ");
	c = frac_reduce(b);
	frac_print(c);
	printf("\n");

	frac_print(a);
	printf(" * ");
	frac_print(b);
	printf(" = ");
	c = frac_mul(a, b);
	frac_print(c);
	printf("\n");
	return 0;
}

